//
//     File Name: FTLPTTST.PRG
//       Project: fischer`techniek interfacing
//   Description: test program for ft LPT(30520) interface and optional slave module
//      Language: xbase++ 
//           dll: uses umFish30.dll(via ft30520.prg,obj)
//        Author: Rene Nooteboom
//         Email: r.nooteboom2@chello.nl
//  Date created: 27-08-2005
//  Date updated: 02/09/2006 12:36
//     Exec File: ftlpttst.exe
//     Copyright: (c) 2005 by Noot Systems Amsterdam
//
#include "inkey.ch"
#include "common.ch"
#include "noot.ch"
#include "ft.ch"
#include "umfish30.ch"
#include "ftlpttst.ch"
//
STATIC lExtension:=FALSE
//
FUNCTION main()
 LOCAL nSelectedMotor:=M1,nkey:=0,i
 Initialize()
 Set Cursor off
 DO WHILE !(LastKey() == K_ESC)
  @ 3,60 SAY nSelectedMotor PICTURE "9"
  FOR i := E1 TO E8
   @ i+2,5 SAY LTOC(FtLSensor(i))
  Next i
  If lExtension
   FOR i := E9 TO E16
    @ i+2,5 SAY LTOC(FtLSensor(i))
   Next i
  endif 
  If FtLAnalogScan()
   @ 19,5 SAY FtLAD(EX) PICTURE "99999999"
   @ 20,5 SAY FtLAD(EY) PICTURE "99999999"
  EndIf
  DO CASE
   CASE nkey == asc("1")
    nSelectedMotor := M1
   CASE nkey == asc("2")
    nSelectedMotor := M2
   CASE nkey == asc("3")
    nSelectedMotor := M3
   CASE nkey == asc("4")
    nSelectedMotor := M4
   Otherwise
  EndCase
  If lExtension
   Do CASE
    CASE nkey == asc("5")
     nSelectedMotor := M5
    CASE nkey == asc("6")
     nSelectedMotor := M6
    CASE nkey == asc("7")
     nSelectedMotor := M7
    CASE nkey == asc("8")
     nSelectedMotor := M8
    Otherwise
   EndCase 
  EndIf
  Do Case
   CASE Upper(Chr(nkey)) == "R" 
    FtLMotor(nSelectedMotor,MCW)
    @ nSelectedMotor+3,44 SAY "MCW "
   CASE Upper(Chr(nkey)) == "L" 
    FtLMotor(nSelectedMotor,MCCW)
    @ nSelectedMotor+3,44 SAY "MCCW"
   CASE Upper(Chr(nkey)) == "O" 
    FtLMotor(nSelectedMotor,MOFF)
    @ nSelectedMotor+3,44 SAY "MOFF"
   OTHERWISE
  EndCase
  UpdateLoops()
  nkey := Inkey(0.01) // wait 0.01s
 EndDo
 CloseApplication()
RETURN NIL
//
PROCEDURE Initialize()
 SetMouse(FALSE)
 Set Scoreboard OFF
 Set Cursor ON
 CLS
 @ 1,2 SAY "Fischer Techniek LPT(30520)-Interface diagnose(using umFish30.dll)"
 If FtLInit() == -1
  CloseApplication()
 EndIf
 lExtension := FtLExtension()
 @ 2,2 SAY "Used port:" + FtLUsedLptPort() + " ,PollInterval:" + ;
  AllTrim(Str(FtLPollInterval(),4,0)) + "mS" + " ,LPTDelay:" + ;
  AllTrim(Str(FtLLptDelay(),3,0))
 @ 3,1 SAY "E1"
 @ 4,1 SAY "E2"
 @ 5,1 SAY "E3"
 @ 6,1 SAY "E4"
 @ 7,1 SAY "E5"
 @ 8,1 SAY "E6"
 @ 9,1 SAY "E7"
 @ 10,1 SAY "E8"
 If lExtension
  @ 11,1 SAY "E9"
  @ 12,1 SAY "E10"
  @ 13,1 SAY "E11"
  @ 14,1 SAY "E12"
  @ 15,1 SAY "E13"
  @ 16,1 SAY "E14"
  @ 17,1 SAY "E15"
  @ 18,1 SAY "E16"
 EndIf
 @ 3,40 SAY "Selected motor:"
 @ 4,40 SAY "M1  MOFF"
 @ 5,40 SAY "M2  MOFF"
 @ 6,40 SAY "M3  MOFF"
 @ 7,40 SAY "M4  MOFF"
 If lExtension
  @ 8,40 SAY "M5  MOFF"
  @ 9,40 SAY "M6  MOFF"
  @ 10,40 SAY "M7  MOFF"
  @ 11,40 SAY "M8  MOFF" 
 EndIf
 If FtLAnalogScan()
  @ 19,1 SAY "EX"
  @ 20,1 SAY "EY"
 EndIf
 @ 21,1 SAY "Number of loops:"
 @ 22,1 SAY "Use keys: 1-4(-8),L,R,O and escape"
Return
//
PROCEDURE CloseApplication()
 FtLCloseAll()
 Quit
Return
//
PROCEDURE UpdateLoops()
 STATIC nCount := 0
 @ 21,22 SAY ++nCount
RETURN
//
// end FtLpttst.prg
//
