//
//     File Name: MFACETST.PRG
//       Project: ft interfacing
//   Description: test program for multiface
//      Language: xBase++
//        Author: Rene Nooteboom
//  Date created: 27-08-2005
//  Date updated: 26/04/2006 12:42
//     Exec File: mfacetst.exe
//     Copyright: (c) 2005 by Noot Systems Amsterdam
//
//
//
#include "common.ch"
#include "inkey.ch"
#include "noot.ch"
#include "ft.ch"
#include "mfacetst.ch"
//
STATIC nLptPort := 1
//
FUNCTION Main()
 LOCAL nSelectedMotor:=M1,nKeyPressed:=0,i
 Initialize()
 DO WHILE !(lastkey() == K_ESC)
  @ 3,60 SAY nSelectedMotor PICTURE "9"
  FOR i := E1 TO E8
   @ i+2,5 SAY LTOC(MfSensor(nLptPort,i))
  NEXT
  DO CASE
   CASE nKeyPressed == asc("1")
    nSelectedMotor := M1
   CASE nKeyPressed == asc("2")
    nSelectedMotor := M2
   CASE nKeyPressed == asc("3")
    nSelectedMotor := M3
   CASE nKeyPressed == asc("4")
    nSelectedMotor := M4
   CASE nKeyPressed == asc("R") .OR. nKeyPressed == asc("r")
    MfMotor(nLptPort,nSelectedMotor,MCW)
    @ nSelectedMotor+3,44 SAY "MCW "
   CASE nKeyPressed == asc("L") .OR. nKeyPressed == asc("l")
    MfMotor(nLptPort,nSelectedMotor,MCCW)
    @ nSelectedMotor+3,44 SAY "MCCW"
   CASE nKeyPressed == asc("O") .OR. nKeyPressed == asc("o")
    MfMotor(nLptPort,nSelectedMotor,MOFF)
    @ nSelectedMotor+3,44 SAY "MOFF"
   OTHERWISE
  ENDCASE
  UpdateLoops()
  nKeyPressed := inkey(0.01)
 ENDDO
 CloseAppl()
RETURN NIL
//
PROCEDURE Initialize()
 Set Cursor off
 Set Scoreboard off
 CLS
 @ 1,20 SAY "MultiFace Interface diagnose"
 @ 3,1 SAY "E1"
 @ 4,1 SAY "E2"
 @ 5,1 SAY "E3"
 @ 6,1 SAY "E4"
 @ 7,1 SAY "E5"
 @ 8,1 SAY "E6"
 @ 9,1 SAY "E7"
 @ 10,1 SAY "E8"
 @ 3,40 SAY "Selected motor:"
 @ 4,40 SAY "M1  MOFF"
 @ 5,40 SAY "M2  MOFF"
 @ 6,40 SAY "M3  MOFF"
 @ 7,40 SAY "M4  MOFF"
 @ 8,40 SAY "Use keys : 1-4,R,L and O"
 @ 22,1 SAY "Number of loops:"
 nLptPort := MfInit()
 IF nLptPort < 1
  CloseAppl()
 ELSE
  @ 12,1 SAY "LPT" + str(nLptPort,1) + "[IO=" + MfHexIO(nLptPort) + "h]"
 ENDIF
RETURN
//
PROCEDURE CloseAppl()
 MfCloseAll()
 Quit
RETURN
//
PROCEDURE UpdateLoops()
 STATIC nCount := 0
 @ 22,22 SAY ++nCount
RETURN
//
// end mfacetst.prg
//
