// 
// module : TrafficLight.prg
// project : TrafficLight cross-junction simulation with Fischer Technik
// language : xBase++ & xbToolsIII (v.1.90(build 0331))
// library : ftroboii.obj (uses umFish40.dll)
// author: Rene Nooteboom
// email: r.nooteboom2@chello.nl
// mobile: +31 (0)6 2182 7921
// created: 26/08/2006 21:01
// updated: 03/09/2006 11:45
//
#include "common.ch"
#include "Gra.ch"
#include "Xbp.ch"
#include "Appevent.ch"
#include "inkey.ch"
#include "Font.ch"
#include "noot.ch"
#include "ft.ch"
#include "umfish40.ch"
#include "TrafficLight.ch"
//
Static iHandle:=0 // interface handle
Static lBuzzer:=FALSE,lAutomatic:=TRUE,lStop:=FALSE
Static oRB_Automatic,oRB_OnRequest,oCB_Buzzer
Static nRedTime:=DEFAULT_RED_TIME,nAmberTime:=DEFAULT_AMBER_TIME, ;
 nGreenTime:=DEFAULT_GREEN_TIME
Static oSLE_Red,oSLE_Amber,oSLE_Green
Static oSB_Red,oSB_Amber,oSB_Green
Static oPB_Start,oPB_Stop
//
// overloading of AppSys()
//
// AppSys() is the initialization procedure which will be called prior
//  to the main procedure.  This procedure should also create the application
//  window, the menu, and the help object.  You can also perform any system
//  wide setup work that you'd like.        
//
// In this application we will create a GUI-dialog window instead
//  of the default xbase++ hybrid XbpCrt()-console&gui window
//
Procedure AppSys()
 LOCAL oDialog,aSize[2],nWidth:=600,nHeight:=400,nX,nY
//
 aSize := SetAppWindow():currentSize()
 nX := 0.05 * aSize[1]
 nY := 0.05 * aSize[2]
 oDialog := XbpDialog():new()
 oDialog:Title := AppName(TRUE)
 oDialog:Icon := ID_ICON_EXE
 oDialog:Border := XBPDLG_THINBORDER  
 oDialog:MaxButton := FALSE
 oDialog:MinButton := TRUE
 oDialog:MoveWithOwner := TRUE
 oDialog:TaskList := TRUE
 oDialog:TitleBar := TRUE
 oDialog:close := {||CloseApplication()}  
 oDialog:create(,,{nX,nY},{nWidth,nHeight})
//
 oDialog:drawingArea:SetColorBG(GRA_CLR_PALEGRAY)
 oDialog:drawingArea:SetFontCompoundName("11.Alaska Crt")
//
 oDialog:show()
 SetAppWindow(oDialog)
 SetAppFocus(oDialog)
// 
 Set CENTURY ON
//
 Return
//
// overloading of dbeSys()
//
// this application uses no databases
//
PROCEDURE dbeSys()
 SET COLLATION TO ASCII    //  Host system's sorting 
 Set Date Format to "dd-mm-yyyy" 
 Return
//
Procedure CloseApplication()
 FtRCloseAll()
 Quit
 Return
//
Procedure Main()
 LOCAL nEvent,mp1,mp2
 LOCAL oDialog,oXbp,odrawingArea
 LOCAL oSt_Gr_Mode,oSt_Gr_Time // static group type 
//
 If ((iHandle := FtRInit()) == -1) // initialize interface & get handle
  ALARMTONE
  MsgBox("Error: initializing interface")
  CloseApplication()
 EndIf
//
 oDialog := SetAppWindow()
 odrawingArea := oDialog:drawingArea
//
// creation of all the Xbp-dialog objects
// generated with the xBase++ Form Designer
// source code generated and afterwards adapted&tuned
//
 oPB_Start := XbpPushButton():new( odrawingArea,, {30,40}, {120,40})
 oPB_Start:caption := "Start"
 oPB_Start:tabStop := .T.
 oPB_Start:create()
 oPB_Start:activate := {|| StartTrafficLight() }

 oPB_Stop := XbpPushButton():new( odrawingArea, , {200,40}, {120,40})
 oPB_Stop:caption := "Stop"
 oPB_Stop:tabStop := .T.
 oPB_Stop:create()
 oPB_Stop:activate := {|| lStop := TRUE }

 oXbp := XbpPushButton():new( odrawingArea,, {380,40}, {120,40})
 oXbp:caption := "Exit"
 oXbp:tabStop := .T.
 oXbp:create()
 oXbp:activate := {|| CloseApplication() }
 
 oSt_Gr_Mode := XbpStatic():new( odrawingArea, , {130,150}, {120,120})
 oSt_Gr_Mode:caption := "Mode"
 oSt_Gr_Mode:clipSiblings := .T.
 oSt_Gr_Mode:type := XBPSTATIC_TYPE_GROUPBOX
 oSt_Gr_Mode:create()

 oRB_Automatic := XbpRadioButton():new( oSt_Gr_Mode, , {10,50}, {100,30})
 oRB_Automatic:caption := "Automatic"
 oRB_Automatic:group := XBP_WITHIN_GROUP
 oRB_Automatic:selection := TRUE 
 oRB_Automatic:tabStop := .T.
 oRB_Automatic:create()
 oRB_Automatic:selected := {|lSel|lAutomatic := lSel }
 oRB_Automatic:setData(lAutomatic)

 oRB_OnRequest := XbpRadioButton():new( oSt_Gr_Mode , ,{10,10}, {100,30})
 oRB_OnRequest:caption := "On Request"
 oRB_OnRequest:group := XBP_WITHIN_GROUP
 oRB_OnRequest:tabStop := TRUE
 oRB_OnRequest:create()
 oRB_OnRequest:selected := {|lSel| lAutomatic := !lSel }
 oRB_OnRequest:setData(!lAutomatic)

 oCB_Buzzer := XbpCheckBox():new( odrawingArea, , {140,100}, {120,30})
 oCB_Buzzer:caption := "with Buzzer"
 oCB_Buzzer:selection := FALSE
 oCB_Buzzer:tabStop := .T.
 oCB_Buzzer:create()
 oCB_Buzzer:selected := {|lChk|lBuzzer := lChk }
 oCB_Buzzer:setData(lBuzzer)

 oXbp := XbpStatic():new( odrawingArea, , {112,325}, {420,25})
 oXbp:autoSize := .T.
 oXbp:caption := "Fischer Technik Traffic Light Control System"
 oXbp:clipSiblings := .T.
 oXbp:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_CENTER
 oXbp:create()
 
 oXbp := XbpStatic():new( odrawingArea, , {90,300}, {420,25})
 oXbp:autoSize := .T.
 oXbp:caption := "[ a xBase++ and umFish cooperation demo project ]"
 oXbp:clipSiblings := .T.
 oXbp:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_CENTER
 oXbp:create()

 oSB_Red := XbpStatic():new( odrawingArea, , {30,250}, {48,48})
 oSB_Red:caption := ID_BMP_GREYED
 oSB_Red:clipSiblings := .T.
 oSB_Red:type := XBPSTATIC_TYPE_BITMAP
 oSB_Red:create()

 oSB_Amber := XbpStatic():new( odrawingArea, , {30,190}, {48,48} )
 oSB_Amber:caption := ID_BMP_GREYED
 oSB_Amber:clipSiblings := .T.
 oSB_Amber:type := XBPSTATIC_TYPE_BITMAP
 oSB_Amber:create()

 oSB_Green := XbpStatic():new( odrawingArea, , {30,130}, {48,48} )
 oSB_Green:caption := ID_BMP_GREYED
 oSB_Green:clipSiblings := .T.
 oSB_Green:type := XBPSTATIC_TYPE_BITMAP
 oSB_Green:create()

 oSt_Gr_Time := XbpStatic():new( odrawingArea, , {340,100}, {240,175})
 oSt_Gr_Time:caption := "Time(seconds)"
 oSt_Gr_Time:clipSiblings := .T.
 oSt_Gr_Time:type := XBPSTATIC_TYPE_GROUPBOX
 oSt_Gr_Time:create()

 oSLE_Red := XbpSLE():new( oSt_Gr_Time, , {120,120}, {100,25})
 oSLE_Red:group := XBP_WITHIN_GROUP
 oSLE_Red:bufferLength := 4
 oSLE_Red:dataLink := {|x|If(x==NIL,AllTrim(Str(nRedTime,4,0)),nRedTime:=Val(x))}
 oSLE_Red:killInputFocus := {|x,y,obj|obj:getData()}
 oSLE_Red:validate := {|o|IS_CYFERS(AllTrim(o:editBuffer()))}
 oSLE_Red:tabStop := .T.
 oSLE_Red:create()
 oSLE_Red:setData()

 oSLE_Amber := XbpSLE():new( oSt_Gr_Time, , {120,70}, {100,25} )
 oSLE_Amber:group := XBP_WITHIN_GROUP
 oSLE_Amber:bufferLength := 4
 oSLE_Amber:dataLink := {|x|If(x==NIL,AllTrim(Str(nAmberTime,4,0)),nAmberTime:=Val(x))}
 oSLE_Amber:killInputFocus := {|x,y,obj|obj:getData()}
 oSLE_Amber:validate := {|o|IS_CYFERS(AllTrim(o:editBuffer()))}
 oSLE_Amber:tabStop := .T. 
 oSLE_Amber:create()
 oSLE_Amber:setData()

 oSLE_Green := XbpSLE():new( oSt_Gr_Time, , {120,10}, {100,25} )
 oSLE_Green:group := XBP_WITHIN_GROUP
 oSLE_Green:bufferLength := 4
 oSLE_Green:dataLink := {|x|If(x==NIL,AllTrim(Str(nGreenTime,4,0)),nGreenTime:=Val(x))}
 oSLE_Green:killInputFocus := {|x,y,obj|obj:getData()}
 oSLE_Green:validate := {|o|IS_CYFERS(AllTrim(o:editBuffer()))}
 oSLE_Green:tabStop := .T. 
 oSLE_Green:create()
 oSLE_Green:setData()

 oXbp := XbpStatic():new( oSt_Gr_Time, , {10,120}, {80,25})
 oXbp:caption := "Red"
 oXbp:clipSiblings := .T.
 oXbp:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_CENTER
 oXbp:create()

 oXbp := XbpStatic():new( oSt_Gr_Time, , {10,70}, {80,25})
 oXbp:caption := "Amber"
 oXbp:clipSiblings := .T.
 oXbp:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_CENTER
 oXbp:create()

 oXbp := XbpStatic():new(oSt_Gr_Time, , {10,10}, {80,25})
 oXbp:caption := "Green"
 oXbp:clipSiblings := .T.
 oXbp:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_CENTER
 oXbp:create() 
 
 oDialog:show()
 
 oPB_Stop:disable()  
//
// the main event loop 
//
 nEvent := xbe_None
 Do While nEvent <> xbeP_Close
  nEvent := AppEvent(@mp1,@mp2,@oXbp,0) // wait until an event happens 
  oXbp:handleEvent(nEvent,mp1,mp2 )
//
  Do Case 
   Case nEvent == xbeP_Quit
    CloseApplication()
   Case nEvent == xbeP_Close
    CloseApplication()
   Case lStop
    Exit
   Case nEvent == xbeP_Keyboard
    If mp1 == K_ESC
     Exit
    EndIf
   END // endcase
 EndDo
 CloseApplication()
 Return
//
Procedure InitVariables()
 lStop := FALSE
 nRedTime := DEFAULT_RED_TIME
 oSLE_Red:setData()
 nAmberTime := DEFAULT_AMBER_TIME
 oSLE_Amber:setData() 
 nGreenTime := DEFAULT_GREEN_TIME
 oSLE_Green:setData()
 lAutomatic := TRUE
 oRB_Automatic:setData(lAutomatic)
 oRB_OnRequest:setData(!lAutomatic)
 lBuzzer := FALSE
 oCB_Buzzer:setData(lBuzzer)
 Return
//
Procedure StartTrafficLight()
 LOCAL nPhase:=0,nEvent:=xbe_None,mp1,mp2,oXbp,LightPhases_,lPushed:=FALSE
 LoadColorBitMaps()
 ReadData()
 DisableDialogs()
 oPB_Stop:enable()
 LightPhases_ := CreatePhases() // get the traffic light phases-array
 If lAutomatic  // change lights continuously and automatic
  Do While TRUE  // second event loop for controlling traffic lights
   nEvent := AppEvent(@mp1,@mp2,@oXbp,1) // wait 1 * 1/100s for an event 
   If nEvent <> xbe_None .AND. !(oXbp == NIL)
    oXbp:handleEvent(nEvent,mp1,mp2)
   EndIf
   Do Case 
    Case nEvent == xbeP_Quit
     CloseApplication()
    Case nEvent == xbeP_Close
     CloseApplication()
    Case lStop
     Exit
   END // endcase	
   If nPhase <= 0
    nPhase := 1
    StartStopWatch()
    FtROutput(iHandle,LightPhases_[nPhase][IOUTPUTBYTE])
   Else
    If ElapsedTime() > LightPhases_[nPhase][ITIME]
     If ++nPhase > Len(LightPhases_)
      nPhase := 1
     EndIf
     StartStopWatch()
     FtROutput(iHandle,LightPhases_[nPhase][IOUTPUTBYTE])
    EndIf
   EndIf 
  EndDo
 Else // request mode: only change lights 1-cycle when PUSH_BUTTON is pushed
  lPushed := FALSE
  nPhase := 1
  FtROutput(iHandle,LightPhases_[1][IOUTPUTBYTE])
  Do While TRUE  // second event loop for controlling traffic lights
   nEvent := AppEvent(@mp1,@mp2,@oXbp,1) // wait 1 * 1/100s for an event 
   If nEvent <> xbe_None .AND. !(oXbp == NIL)
    oXbp:handleEvent(nEvent,mp1,mp2)
   EndIf
   Do Case 
    Case nEvent == xbeP_Quit
     CloseApplication()
    Case nEvent == xbeP_Close
     CloseApplication()
    Case lStop
     Exit
   END // endcase		
   If !lPushed 
    If lPushed := FtRSensor(iHandle,PUSH_BUTTON)
     FtRSetLamp(iHandle,WHITE_LIGHT,TRUE) // request done: white light on   
     StartStopWatch()
    EndIf
   EndIf
   If lPushed
    If ElapsedTime() > LightPhases_[nPhase][ITIME]
     If nPhase <  Len(LightPhases_)
      nPhase++
      StartStopWatch()
      FtROutput(iHandle,LightPhases_[nPhase][IOUTPUTBYTE])
      FtROnNr(iHandle,WHITE_LIGHT) 
     Else // one cycle ended ,request done
      nPhase := 1 // request fulfilled return to waiting for pushbutton
      lPushed := FALSE
      FtROutput(iHandle,LightPhases_[1][IOUTPUTBYTE]) 
     EndIf
    EndIf 
   EndIf
  EndDo 
 EndIf
 FtROutput(iHandle,0) // everything off again
 EnableDialogs()
 UnLoadColorBitMaps()
 oPB_Stop:disable()
 InitVariables()
 Return
//
// construct the traffic-light sequence
// 
// this function returns an array with light phases and times
// it could also be easily changed to load from a database (.dbf)
//
// returns traffic light stages and times in phases_
//
// in this version of CreatePhases we use 6 stages(phases)
// phases_(stages) are processed in an eventloop in StartTrafficLight()
//
Function CreatePhases() // create array with the traffic light-stages
 LOCAL phase1_out_byte:=0,phase2_out_byte:=0,phase3_out_byte:=0, ;
  phase4_out_byte:=0,phase5_out_byte:=0,phase6_out_byte:=0,phases_
 phase1_out_byte := setbit(phase1_out_byte,GREEN_WEST,RED_NORTH)
 phase2_out_byte := setbit(phase2_out_byte,AMBER_WEST,RED_NORTH)
 phase3_out_byte := setbit(phase3_out_byte,RED_WEST,RED_NORTH)
 phase4_out_byte := setbit(phase4_out_byte,RED_WEST,GREEN_NORTH)
 If lBuzzer
  phase4_out_byte := setbit(phase4_out_byte,BUZZER)
 EndIf
 phase5_out_byte := setbit(phase5_out_byte,RED_WEST,AMBER_NORTH)
 phase6_out_byte := setbit(phase6_out_byte,RED_WEST,RED_NORTH)
 phases_ := {{phase1_out_byte,nGreenTime},{phase2_out_byte,nAmberTime}, ;
  {phase3_out_byte,BOTH_RED_TIME},{phase4_out_byte,nRedTime}, ;
  {phase5_out_byte,nAmberTime},{phase6_out_byte,BOTH_RED_TIME}}
 Return phases_
//
Procedure EnableDialogs()
 oPB_Start:enable()
 oSLE_Red:enable()
 oSLE_Amber:enable()
 oSLE_Green:enable()
 oCB_Buzzer:enable()
 oRB_Automatic:enable()
 oRB_OnRequest:enable()
 Return
//
Procedure DisableDialogs()
 oPB_Start:disable()
 oSLE_Red:disable()
 oSLE_Amber:disable()
 oSLE_Green:disable()
 oCB_Buzzer:disable()
 oRB_Automatic:disable()
 oRB_OnRequest:disable()
 Return
//
Procedure ReadData()
 oSLE_Red:getData()
 oSLE_Amber:getData()
 oSLE_Green:getData()
 lBuzzer := oCB_Buzzer:getData()
 lAutomatic := oRB_Automatic:getData()
 Return
//
Procedure LoadColorBitMaps()
 oSB_Red:caption := ID_BMP_RED
 oSB_Red:configure()
 oSB_Amber:caption := ID_BMP_AMBER
 oSB_Amber:configure()
 oSB_Green:caption := ID_BMP_GREEN
 oSB_Green:configure()
 Return
//
Procedure UnLoadColorBitMaps()
 oSB_Red:caption := ID_BMP_GREYED
 oSB_Red:configure()
 oSB_Amber:caption := ID_BMP_GREYED
 oSB_Amber:configure()
 oSB_Green:caption := ID_BMP_GREYED
 oSB_Green:configure()
 Return
//
// eof TrafficLight.prg
//